/********************************************************************************
*
* 文件名  ： uart.h
* 负责人  ： 彭鹏(pengpeng@fiberhome.com)
* 创建日期： 20150614
* 版本号  ： v1.0
* 文件描述： cmos hal uart模块头文件
* 版权说明： Copyright (c) 2000-2020 GNU
* 其 他   ： 无
* 修改日志： 无
*
********************************************************************************/
/*---------------------------------- 预处理区 ---------------------------------*/
#ifndef _CMOS_HAL_UART_UART_H_
#define _CMOS_HAL_UART_UART_H_

/************************************ 头文件 ***********************************/
#include "cmos_config.h"
#include "driver.h"

/************************************ 宏定义 ***********************************/

/*********************************** 类型定义 **********************************/
typedef struct cmos_hal_uart_init_para_T_tag{
    cmos_int32_T uart_index;
    cmos_int32_T baud_rate;
}cmos_hal_uart_init_para_T;

/*--------------------------------- 接口声明区 --------------------------------*/

/*********************************** 全局变量 **********************************/
extern const cmos_hal_driver_T g_uart_driver; /* 驱动变量由vfs指示 */


/*********************************** 接口函数 **********************************/
/* 初始化函数 */
void cmos_hal_uart_init(void *para);

/* 轮询发送 用于idle函数 */
cmos_int32_T uart_write_poll(const void *dev_id, const void *buf, cmos_int32_T n_bytes);

#endif /* _CMOS_HAL_UART_UART_H_ */

