/******************************************************************************
 *
 * 文件名  ： mem.c
 * 负责人  ： 彭鹏(pengpeng@fiberhome.com)
 * 创建日期： 20151103 
 * 版本号  ： 1.0
 * 文件描述： 动态内存分配
 * 版权说明： Copyright (c) GNU
 * 其    他： 无
 * 修改日志： 无
 *
 *******************************************************************************/
/*---------------------------------- 预处理区 ---------------------------------*/

/************************************ 头文件 ***********************************/

#include <stdlib.h>
#include "cmos_config.h"

/*----------------------------------- 声明区 ----------------------------------*/

/********************************** 变量声明区 *********************************/

/********************************** 函数声明区 *********************************/

/********************************** 函数实现区 *********************************/
/*******************************************************************************
*
* 函数名  : cmos_malloc
* 负责人  : 彭鹏
* 创建日期: 20151103
* 函数功能: 动态分配内存接口
*
* 输入参数: size 欲分配的字节数
*
* 输出参数: 无
*
* 返回值  : 分配的内存首地址
*
* 调用关系: 无
* 其 它   : 自己实现
*
******************************************************************************/
void *cmos_malloc(cmos_uint32_T size)
{
    return malloc(size);
}

/*******************************************************************************
*
* 函数名  : cmos_free
* 负责人  : 彭鹏
* 创建日期: 20151103
* 函数功能: 动态释放内存接口
*
* 输入参数: ptr 欲释放的地址
*
* 输出参数: 无
*
* 返回值  : 无
*
* 调用关系: 无
* 其 它   : 自己实现
*
******************************************************************************/
void cmos_free(void *ptr)
{
    free(ptr);
}

