/******************************************************************************
 *
 * 文件名  ： blocked.h
 * 负责人  ： 彭鹏(pengpeng@fiberhome.com)
 * 创建日期： 20151211 
 * 版本号  ： v1.0
 * 文件描述： 阻塞任务接口
 * 版权说明： Copyright (c) 2000-2020 GNU
 * 其    他： 无
 * 修改日志： 无
 *
 *******************************************************************************/

/*---------------------------------- 预处理区 ---------------------------------*/
#ifndef _CMOS_TASK_POOL_BLOCKED_H_
#define _CMOS_TASK_POOL_BLOCKED_H_

/************************************ 头文件 ***********************************/
#include "cmos_config.h"
#include "tcb.h"

/************************************ 宏定义 ***********************************/
/*******************************************************************************
 *
 * 阻塞类型
 * cmos_blocked_delay           0
 * cmos_blocked_suspend         1
 *
 ******************************************************************************/
#define CMOS_TASK_POOL_BLOCKED_TYPE_MAX (2)

/*********************************** 类型定义 **********************************/
typedef enum{
    cmos_blocked_delay_E = 0x00,
    cmos_blocked_suspend_E = 0x01
}cmos_blocked_type_T;

/*--------------------------------- 接口声明区 --------------------------------*/

/*********************************** 全局变量 **********************************/

/*********************************** 接口函数 **********************************/
void cmos_task_pool_blocked_add(const cmos_task_tcb_T *tcb, cmos_blocked_type_T type); /* 加入阻塞任务 */
void cmos_task_pool_blocked_del(const cmos_task_tcb_T *tcb, cmos_blocked_type_T type); /* 移出阻塞任务 */
void cmos_task_pool_blocked_update_tick(void); /* tick定时到 更新相关数据结构 */

#endif // #ifndef _CMOS_TASK_POOL_BLOCKED_H_

